Object subclass:#CompilerTest
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'Tests - Compiler'
!


!CompilerTest methodsFor:'test - inlined'!

test_even:arg
    ^ arg even

    "
     self new test_even:nil               
     self new test_even:123
     self new test_even:122
     self new test_even:(100 factorial)
    "
!

test_isInteger:arg
    ^ arg isInteger

    "
     self new test_isInteger:nil               
     self new test_isInteger:123
     self new test_isInteger:(100 factorial)
    "
!

test_isNotInteger:arg
    ^ arg isInteger not

    "
     self new test_isNotInteger:nil               
     self new test_isNotInteger:123
     self new test_isNotInteger:(100 factorial)
    "
!

test_odd:arg
    ^ arg odd

    "
     self new test_odd:nil               
     self new test_odd:123   
     self new test_odd:122     
     self new test_odd:(100 factorial)  
    "
! !

!CompilerTest methodsFor:'tests - booleans'!

testAnd:arg1 _:arg2
    ^ arg1 & arg2

    "
     self new testAnd:true _:true.      
     self new testAnd:true _:false.     
     self new testAnd:false _:true.     
     self new testAnd:false _:false.    
     self new testAnd:false _:nil.      
     self new testAnd:true _:nil. 
     self new testAnd:nil _:false.
     self new testAnd:nil _:true.
     self new testAnd:1234 _:true.
     self new testAnd:1234 _:false.
     self new testAnd:true _:1234.   
     self new testAnd:false _:1234.  
    "
!

testNot1:arg
    ^ arg not

    "
     self new testNot1:true.   
     self new testNot1:false.
     self new testNot1:1234.
    "
!

testNot2:arg1 _:arg2
    ^ arg1 not & arg2 not

    "
     self new testNot2:true  _:true.   
     self new testNot2:false _:true.
     self new testNot2:true  _:false.
     self new testNot2:false _:false.

     self new testNot2:false _:1234.
     self new testNot2:true  _:1234.
     self new testNot2:1234  _:true.
     self new testNot2:1234  _:false.
     self new testNot2:1234  _:2345.
    "
!

testOr:arg1 _:arg2
    ^ arg1 | arg2

    "
     self new testOr:true _:true.      
     self new testOr:true _:false.     
     self new testOr:false _:true.     
     self new testOr:false _:false.    
     self new testOr:false _:nil.      
     self new testOr:true _:nil. 
     self new testOr:nil _:false.
     self new testOr:nil _:true.
     self new testOr:1234 _:true.
     self new testOr:1234 _:false.
     self new testOr:true _:1234.   
     self new testOr:false _:1234.  
    "
! !

!CompilerTest methodsFor:'tests - constant folding'!

testFloat_pi
    ^ Float pi
!

testFloat_unity
    ^ Float unity
!

testFloat_zero
    ^ Float zero
!

testSmalltalk_if_else_isSmalltalkX
    Smalltalk isSmalltalkX ifTrue:[
        ^ 'yes'
    ] ifFalse:[
        ^ 'no'
    ]
!

testSmalltalk_if_else_isVisualWorks
    Smalltalk isVisualWorks ifTrue:[
        ^ 'yes'
    ] ifFalse:[
        ^ 'no'
    ]
!

testSmalltalk_if_isSmalltalkX
    Smalltalk isSmalltalkX ifTrue:[
        ^ 'yes'
    ].
    ^ 'no'
!

testSmalltalk_if_isSqueak
    Smalltalk isSqueak ifTrue:[
        ^ 'yes'
    ].
    ^ 'no'
!

testSmalltalk_if_isVisualWorks
    Smalltalk isVisualWorks ifTrue:[
        ^ 'yes'
    ].
    ^ 'no'
!

testSmalltalk_isSmalltalkX
    ^ Smalltalk isSmalltalkX
!

testSmalltalk_isSqueak
    ^ Smalltalk isSqueak
!

testSmalltalk_isVisualAge
    ^ Smalltalk isVisualAge
!

testSmalltalk_isVisualWorks
    ^ Smalltalk isVisualWorks
!

testUnaryFolding
    self testFloat_pi ~= (Float perform:#pi) ifTrue:[self halt].
    self testFloat_unity ~= (Float perform:#unity) ifTrue:[self halt].
    self testFloat_zero ~= (Float perform:#zero) ifTrue:[self halt].

    self testSmalltalk_isSmalltalkX ~= (Smalltalk perform:#isSmalltalkX) ifTrue:[self halt].
    self testSmalltalk_isSqueak ~= (Smalltalk perform:#isSqueak) ifTrue:[self halt].
    self testSmalltalk_isVisualWorks ~= (Smalltalk perform:#isVisualWorks) ifTrue:[self halt].
    self testSmalltalk_isVisualAge ~= (Smalltalk perform:#isVisualAge) ifTrue:[self halt].

    "
     self basicNew testUnaryFolding
    "
! !

!CompilerTest class methodsFor:'documentation'!

version
    ^ '$Header$'
! !
